// ****************************************************************************
//  The Code Cave's DynDNS Updater                    					    01/Mar/2007
//  Written by Brian Layman (AKA Capt. Queeg AKA SilverPaladin)
//  Visit him at http://www.TheCodeCave.com
//
//  This is a demo of how to recreate a browser session including gets,
//  posts, password entries, and session logging.  It turns the 1and1.com
//  control panel into a DynDNS service.
//
//  Warning: It's quite certain that the 1and1.com control panel was not
//    optimized for automated usage.  AFAIK this does not violate any of my
//    usage agreements.  I could be wrong and your account might be under
//    newer/older terms that differ from mine.  Review your usage agreement.
//    I am not responsible for your usage of this program or any harm that is
//    caused technically, financially or contractually. In fact, better
//    yet, do not run this example at all. You should stop right now and erase
//    the files.  For if it causes your URL to now be linked to some XXX porn
//    site, if it erases all users from your computer, or if it makes your
//    sister break up with her lawyer boyfriend and start dating a caver, it
//    is not my fault.  (Actually that last one might be an improvement, but
//    it is still not my fault.) The fact of the matter is, computers
//    have a mind of their own and we programmers live on the wild side.
//
//  Usage: TCC_DDNSUpdater [URL Password DOMAINID]
//   Running with no parameters causes the UI to show and you must press
//   buttons for anything to happen.  Pass in the url that you wish to update
//   followed by the main password for your account, followed by the domain
//   ID for the URL you're gonna process and the program will update to the
//   current external IP address and terminate.  This works well when placed
//   in the registry.
//
//  Licensing - You can use this source as you will.  It's free for
//    commercial, shareware and gpl use as you like.  I hope it helps.
//    If this program & source really helps you out, please visit
//    http://www.thecodecave.com/did-that-help/ and read more.
//
//  History:
//	   06/Jun/2006 - BL - Created
//
// ****************************************************************************
unit TCC_DDNSUpdater_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SHDocVw, mshtml, Httpapp, ExtCtrls, COMObj, ActiveX,
  jpeg, WinSock;

type
  Tfrm1and1DynDNS = class(TForm)
    WebBrowser: TWebBrowser;
    Panel1: TPanel;
    editUserName: TEdit;
    editPassword: TEdit;
    editIP0: TEdit;
    editIP1: TEdit;
    editIP2: TEdit;
    editIP3: TEdit;
    btnGetExternalIP: TButton;
    btnGetSessionID: TButton;
    btnLogin: TButton;
    btnGetDomainID: TButton;
    btnSetDomainIP: TButton;
    btnDoItAll: TButton;
    memoHeaders: TMemo;
    editDomainID: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    editIP: TEdit;
    Bevel1: TBevel;
    Label5: TLabel;
    Image1: TImage;
    editSessionID: TEdit;
    Label6: TLabel;
    Label8: TLabel;
    xboxShowNavigationData: TCheckBox;
    procedure btnGetExternalIPClick(Sender: TObject);
    procedure btnGetSessionIDClick(Sender: TObject);
    procedure btnLoginClick(Sender: TObject);
    procedure btnGetDomainIDClick(Sender: TObject);
    procedure btnSetDomainIPClick(Sender: TObject);
    procedure btnDoItAllClick(Sender: TObject);
    procedure editUserNameChange(Sender: TObject);
    procedure WebBrowserBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    lSession: String;
    function GetSession(Action: String): String;
    function GetDomainID(Browser: TWebBrowser; URL: String): String;
  public
    { Public declarations }
  end;

var
  frm1and1DynDNS: Tfrm1and1DynDNS;

const
  TIMEOUTSEC_BROWSER = 30;
  ADMIN_URL = 'https://admin.1and1.com';
  MY_IP_URL = 'http://MyIP.TheCodeCave.com';  // An url that sets the doc title to the current external IP address.

implementation

{$R *.DFM}

{******************************************************************************
  Helper Routines
 ******************************************************************************}

{******************************************************************************
  URLMatchesIP - Originally GetIPFromHost by eXeco
  A quick WinSock function to get the current IP address of the URL.  There
  are many ways to do this, I just had this code handy ATM.
 ******************************************************************************}
function URLMatchesIP( HostName, IPAddr: String): Boolean;
type
  Name = Array[0..100] of Char;
var
  HEnt: pHostEnt;
  WSAData: TWSAData;
  FoundPos: Integer;
  URLIPAddr: String;
  WSAErr: String;
begin // URLMatchesIP
  // Assume it does.
  Result := TRUE;

  // Create a socket
  if (WSAStartup($0101, WSAData) <> 0)
  then begin
    WSAErr := 'Winsock is not responding."';
    exit;
  end;

  // Clear the protocol if it was set
  FoundPos := Pos('//', HostName);
  if (FoundPos > 0)
  then Delete(HostName, 1, FoundPos + 1);

  // Clear the trailing location, if it was set
  FoundPos := Pos('/', HostName);
  if (FoundPos > 0)
  then Delete(HostName, FoundPos, (Length(HostName) - (FoundPos + 1)));

  // Use Get Host By Name to do the actual work
  HEnt := GetHostByName(PChar(HostName));

  // Convert the resulting integer array to a string, or set the error flag.
  if (WSAGetLastError = 0)
  then begin
    for FoundPos := 0 to (HEnt^.H_Length - 1)
    do URLIPAddr := Concat(URLIPAddr, IntToStr(Ord(HEnt^.H_Addr_List^[FoundPos])) + '.');
    SetLength(URLIPAddr, Length(URLIPAddr) - 1);
  end
  else WSAErr := 'WinSock Error: ' + IntToStr(WSAGetLastError) + '.  Could not continue.' ;

  // Close the socket
  WSACleanup;

  // Raise an error if there was a problem.
  if (WSAErr <> '')
  then raise Exception.Create(WSAErr);

  // Compare the two strings and return a boolean
  Result := (IPAddr = URLIPAddr);
end;  // URLMatchesIP

{******************************************************************************
  VariantToStr
  A simple safe conversion routine that ensures we have a good string value
 ******************************************************************************}
function VariantToStr(AVar: OleVariant): string;
var
  i: integer;
  V: olevariant;
begin // VariantToStr
  if (VarType(AVar) = (varVariant or varByRef))
  then V := Variant(TVarData(AVar).VPointer^)
  else V := AVar;

  if (VarType(V) = (varByte or varArray))
  then begin
    try
      for I := VarArrayLowBound(V,1) to VarArrayHighBound(V,1)
      do Result := Result + Chr(Byte(V[i]));
    except;
      Result := '';
    end
  end
  else Result := V;
end;   // VariantToStr

{******************************************************************************
  ParseIP
  Parse a standard format IP address
 ******************************************************************************}
procedure ParseIP(IPAddress: String; var IP0, IP1, IP2, IP3: String);
var
  FoundPos: Integer;
begin // ParseIP
  try
    FoundPos := Pos('.', IPAddress);
    IP0 := Copy(IPAddress, 0, FoundPos - 1);
    IPAddress := Copy(IPAddress, FoundPos + 1, 255);
    FoundPos := Pos('.', IPAddress);
    IP1 := Copy(IPAddress, 0, FoundPos - 1);
    IPAddress := Copy(IPAddress, FoundPos + 1, 255);
    FoundPos := Pos('.', IPAddress);
    IP2 := Copy(IPAddress, 0, FoundPos - 1);
    IPAddress := Copy(IPAddress, FoundPos + 1, 255);
    IP3 := Copy(IPAddress, 0, 3);
  except
    raise Exception.Create('Invalid Data: The IP address must be four number seperated by periods. (eg: 255.1.0.3');
  end
end;  //ParseIP

{******************************************************************************
  GotoURL
  Navigates to the to the passed URL using the passed browser.
 ******************************************************************************}
function GotoURL(Browser: TWebBrowser; URL: String; TimeOutSec: Integer = TIMEOUTSEC_BROWSER): Boolean;
var
  TimeStart: TDateTime;
  Flags: OLEVariant;
begin // GotoURL
  // Set the flags so that there is no history kept of this visit.
  Flags := navNoHistory;

  // Go to the specified website
  Browser.Navigate(WideString(URL), Flags);



  TimeStart := Now;

  // Now twiddle our thumbs until the page loads.
  repeat
    Application.ProcessMessages;
  until (Browser.ReadyState >= READYSTATE_COMPLETE) or ((Now - TimeStart) * SecsPerDay > TimeOutSec);

  Result := (Browser.ReadyState >= READYSTATE_COMPLETE)
end;  // GotoURL

{******************************************************************************
  NumberOfForms
  Retrieves the number of forms used on a page.  Could be used in this routine
  for error checking.
 ******************************************************************************}
function NumberOfForms(Document: IHTMLDocument2): integer;
var
  Forms: IHTMLElementCollection;
begin // NumberOfForms
  Forms := (Document.Forms as IHTMLElementCollection);
  Result := Forms.Length;
end;  // NumberOfForms

{******************************************************************************
  GetFormByNumber
  Retrieves a specific form on the current page based upon the ordering.
  Returns NIL if not found.
 ******************************************************************************}
function GetFormByNumber(Document: IHTMLDocument2; FormNum: Integer = 0): IHTMLFormElement;
var
  Forms: IHTMLElementCollection;
begin // GetFormByNumber
  Forms := (Document.Forms as IHTMLElementCollection);
  if (FormNum < Forms.Length)
  then Result := Forms.Item(FormNum,'') as IHTMLFormElement
  else Result := NIL;
end;  // GetFormByNumber

{******************************************************************************
  GetFormByName
  Retrieves a specific form on the current page based upon the name of the
  form.
  Returns NIL if not found.
 ******************************************************************************}
function GetFormByName(Document: IHTMLDocument2; const FormName: String): IHTMLFormElement;
var
  Forms: IHTMLElementCollection;
begin // GetFormByName
  Forms := (Document.Forms as IHTMLElementCollection);
  Result := Forms.Item(FormName,'') as IHTMLFormElement
end;  // GetFormByName

{******************************************************************************
  GetFormAction
  Determins the action that will be taken by the form when it is submitted.
  This is an URL of some kind.
 ******************************************************************************}
function GetFormAction(Browser: TWebBrowser; FormNum: Integer = 0): String;
var
  Document: IHTMLDocument2;
  CurForm : IHTMLFormElement;
begin  // GetFormAction
  Result := '';

  if (Assigned(Browser.Document))
  then begin
    Document := Browser.Document AS IHTMLDocument2;
    CurForm := GetFormByNumber(Document);
    Result := CurForm.Action
  end;
end;   // GetFormAction

{******************************************************************************
  SubmitForm
  Submits a webform.
 ******************************************************************************}
function SubmitForm(Browser: TWebBrowser; URL, EncodedDataString: String; TimeOutSec: Integer = TIMEOUTSEC_BROWSER): Boolean;
var
  TimeStart: TDateTime;
  Flags: OLEVariant;
  PostData: OleVariant;
  Headers: OleVariant;
  i: integer;
begin  // SubmitForm
  // Set the flags so that there is no history kept of this visit.
  Flags := navNoHistory;

  // The PostData OleVariant needs to be an array of bytes
  // as large as the string (minus the 0 terminator)
  PostData := VarArrayCreate([0, Length(EncodedDataString)-1], varByte);

  // Now, move the Ordinal value of the character into the PostData array
  for i := 1 to Length(EncodedDataString)
  do PostData[i-1] := Ord(EncodedDataString[i]);

  Headers := 'Content-Type: application/x-www-form-urlencoded'#13#10;

  try
    Browser.Navigate(URL, Flags, EmptyParam, PostData, Headers);

    TimeStart := Now;

    // Now twiddle our thumbs until the page loads.
    repeat
      Application.ProcessMessages;
    until (Browser.ReadyState >= READYSTATE_COMPLETE) or ((Now - TimeStart) * SecsPerDay > TimeOutSec);

    Result := (Browser.ReadyState >= READYSTATE_COMPLETE)
  except
    Result := FALSE;
  end;
end;  // SubmitForm

{******************************************************************************
  GetSession
  Take a look at the action data and find the jsessionid parameter.
  Return it in a string.
 ******************************************************************************}
function Tfrm1and1DynDNS.GetSession(Action: String): String;
var
  FoundPos: Integer;
begin // GetSession
  FoundPos := Pos('jsessionid=', Action);
  if (FoundPos >= 0)
  then Result := Copy(Action, FoundPos + Length('jsessionid='), 38)
  else raise Exception.Create('A current session ID could not be retrieved from 1and1.com.  You probably need an update from TheCodeCave.com or you are offline.');
end;  // GetSession

{******************************************************************************
  GetDomainID
  The Domain ID is embedded in the links on a 1and1 page.
  An optimized version of this program would skip this step and allow the
  Domain ID to be enterred into a field on the form, or passed as a parameter.
 ******************************************************************************}
function Tfrm1and1DynDNS.GetDomainID(Browser: TWebBrowser; URL: String): String;
var
  S: String;
  Links: IHTMLElementCollection;
  CurElement: IHTMLElement;
  LinkIndex: Integer;
  FoundPos: Integer;
  Document: IHTMLDocument2;
begin // GetDomainID
  // If we have a document, do the work.
  if (Assigned(Browser.Document))
  then begin
    // Get the list of links from the document
    Document := Browser.Document AS IHTMLDocument2;
    Links := Document.Links;

    // Iterate the links looking for the right url in their destination
    for LinkIndex := 0 to Links.Length - 1
    do begin
      // Get the first link
      CurElement :=  Links.Item(LinkIndex, '') as IHTMLElement;
      // Its InnerText is what is between the begin and end A tags and what is shown on the screen.
      S := LowerCase(CurElement.InnerText);
      if (Pos(LowerCase(editUserName.Text), S) > 0)
      then begin
        // The OuterHTML is the HTML used to create the link.
        // For this case, it is in this format:
        // '<A class=core_button_normal href="/xml/config/DomainOverview;jsessionid=CAC6B979A5C10B3A3EC435F5D1B8B017.TC64a?__frame=_top&amp;__lf=dns_flow2&amp;__sendingdata=1&amp;domainOverview.DomainIds=****DOMAIN_ID****&amp;__pageflow=settings_wizard_flow&amp;__CMD[DomainOverview]:SELWRP=domainOverview">****DOMAIN_NAME****</A>'
        S := CurElement.OuterHTML;
        // Get the Domain IDs content
        FoundPos := Pos('DomainIds=', S);
        // All Domain IDs are 9 chars long AFAIK.
        Result := Copy(S, FoundPos + Length('DomainIDs='), 9);
        Break;
      end;
    end;
  end;
end;  // GetDomainID



{******************************************************************************
  Event Methods
 ******************************************************************************}

{******************************************************************************
  btnGetSessionIDClick
  Creates a session used to talk to 1and1.com.  This is done by simply
  visiting the admin url.  This is an HTTPS action but all that is handled by
  IE natively.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.btnGetSessionIDClick(Sender: TObject);
var
  Action: String;
var
  Save_Cursor: TCursor;
begin // btnGetSessionIDClick
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;    // Show the hourglass cursor while working
  try
    // Navigate there
    GotoURL(WebBrowser, ADMIN_URL);
    Action := GetFormAction(WebBrowser);
    // Parse the SessionID from the information returned.
    lSession := GetSession(Action);
    editSessionID.Text  := lSession;
  finally
    Screen.Cursor := Save_Cursor;  // Always mouse restore to normal
  end;
end;  // btnGetSessionIDClick

{******************************************************************************
  btnLoginClick
  Performs the login to 1and1.com. This is required and instantiates the
  Session ID and verifies that you have the privileges needed to perform the
  update.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.btnLoginClick(Sender: TObject);
var
  Save_Cursor: TCursor;
begin // btnLoginClick
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;    // Show the hourglass cursor while working
  try
    if (not SubmitForm(WebBrowser,'https://admin.1and1.com/xml/config;jsessionid=' + lSession, '__lf=' + HTTPEncode('HomeFlow') + '&' + '__sendingauthdata=' + HTTPEncode('1') + '&' + 'login.SelectContract=' + HTTPEncode('') + '&' +
      'login.User=' + HTTPEncode(editUserName.Text) + '&' + 'login.Pass=' + HTTPEncode(editPassword.Text) + '&' +
      '__SBMT:d3e177d0:=' + HTTPEncode('')))
    then ShowMessage('FAILED TO LOGIN')
  finally
    Screen.Cursor := Save_Cursor;  // Always mouse restore to normal
  end;
end;  // btnLoginClick

{******************************************************************************
  btnGetExternalIPClick
  Navigates to a page on TheCodeCave.com that assigns the current IP address
  to the title of the page.  You can replace this URL by changing a constant.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.btnGetExternalIPClick(Sender: TObject);
var
  Document: IHTMLDocument2;
  IP0, IP1, IP2, IP3: String;
  Save_Cursor: TCursor;
begin // btnGetExternalIPClick
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;    // Show the hourglass cursor while working
  try
    if (Trim(editIP.Text) = '')
    then begin
      if GotoURL(WebBrowser, MY_IP_URL)
      then begin
        if (Assigned(WebBrowser.Document))
        then begin
          Document := WebBrowser.Document AS IHTMLDocument2;
        end;
      end
      else raise Exception.Create('Could not retrieve current External IP address.' +
                 '  Are you online?  Is access to TheCodeCave.com blocked by content filtering?');
      editIP.Text := Document.Title;
    end;

    // Break apart the IP address
    ParseIP(Trim(editIP.Text), IP0, IP1, IP2, IP3);
    editIP0.Text := IP0;
    editIP1.Text := IP1;
    editIP2.Text := IP2;
    editIP3.Text := IP3;
  finally
    Screen.Cursor := Save_Cursor;  // Always mouse restore to normal
  end;
end;  // btnGetExternalIPClick

{******************************************************************************
  btnGetDomainIDClick
  Each (sub)Domain on 1and1 has an ID.  This remains the same, but since this
  is a teaching demo, we'll retreive it.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.btnGetDomainIDClick(Sender: TObject);
var
  Save_Cursor: TCursor;
begin // btnGetDomainIDClick
  if (Trim(editDomainID.Text) <> '')
  then exit; // If it is set, don't change it.
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;    // Show the hourglass cursor while working
  try
    if (not SubmitForm(WebBrowser, 'https://admin.1and1.com/xml/config/DomainOverview;jsessionid=' + lSession + '?__frame=',
       '__lf=MCPrivacyFlow&__sendingdata=1&__currentindex%5BDomainOverview%5D=0&__SYNT%3Ad1e523d0%3AdomainFilter.Set=true&' +
       '__SYNT%3Ad1e523d0%3AextendedDomainFilter.Set=true&__SYNT%3Ad1e523d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=extendedDomainFilter&' +
       '__SYNT%3Ad1e523d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainFilter&__SYNT%3Ad1e629d0%3AdomainPager.ShowNext=true&' +
       '__SYNT%3Ad1e629d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainPager&__SYNT%3Ad1e635d0%3AdomainPager.ShowLast=true&' +
       '__SYNT%3Ad1e635d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainPager&__SYNT%3Ad1e652d0%3AdomainPager.Interval=5&' +
       '__SYNT%3Ad1e652d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainPager&__SYNT%3Ad1e672d0%3AdomainPager.Interval=20&' +
       '__SYNT%3Ad1e672d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainPager&__SYNT%3Ad1e682d0%3AdomainPager.Interval=50&' +
       '__SYNT%3Ad1e682d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainPager&foo=&' +
       '__SYNT%3Ad1e1108d0%3A__pageflow=settings_wizard_flow&__SYNT%3Ad1e1117d0%3A__pageflow=MCFlow&' +
       '__SYNT%3Ad1e1126d0%3A__pageflow=dns_wizard_flow&__SYNT%3Ad1e1136d0%3A__pageflow=subdomain_delete_flow&' +
       '__SYNT%3Ad1e1154d0%3A__pageflow=settings_info_flow&domainFilter.DomainnameSubstring=&' +
       '__SYNT%3Ad1e1187d0%3AdomainFilter.Set=true&__SYNT%3Ad1e1187d0%3AextendedDomainFilter.Set=true&' +
       '__SYNT%3Ad1e1187d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=extendedDomainFilter&' +
       '__SYNT%3Ad1e1187d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainFilter&domainFilter.DomainType=all&' +
       'extendedDomainFilter.TargetType=all&extendedDomainFilter.FrontpageStatus=all&__SYNT%3Ad1e1295d0%3AdomainFilter.Set=true&' +
       '__SYNT%3Ad1e1295d0%3AextendedDomainFilter.Set=true&__SYNT%3Ad1e1295d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=extendedDomainFilter&' +
       '__SYNT%3Ad1e1295d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainFilter&__SYNT%3Ad1e1395d0%3AselectDomain.Action=reset&' +
       '__SYNT%3Ad1e1395d0%3AdomainOrder.OrderBy=domainname&__SYNT%3Ad1e1395d0%3AdomainOrder.OrderAscending=true&' +
       '__SYNT%3Ad1e1395d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=selectDomain&__SYNT%3Ad1e1395d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainOrder&' +
       '__SYNT%3Ad1e1502d0%3AselectDomain.Action=reset&__SYNT%3Ad1e1502d0%3AdomainOrder.OrderBy=domaintype&' +
       '__SYNT%3Ad1e1502d0%3AdomainOrder.OrderAscending=false&__SYNT%3Ad1e1502d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=selectDomain&' +
       '__SYNT%3Ad1e1502d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainOrder&__SYNT%3Ad1e1702d0%3AselectDomain.Action=reset&' +
       '__SYNT%3Ad1e1702d0%3AdomainOrder.OrderBy=state&__SYNT%3Ad1e1702d0%3AdomainOrder.OrderAscending=false&' +
       '__SYNT%3Ad1e1702d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=selectDomain&' +
       '__SYNT%3Ad1e1702d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=domainOrder&' +
       '&__SBMT%3Ad1e682d0%3A.x=12&__SBMT%3Ad1e682d0%3A.y=10'+
       '&__pageflow=dns_flow2'))
    then ShowMessage('Go to domain list');

    editDomainID.Text := GetDomainID(WebBrowser, editUserName.Text);
  finally
    Screen.Cursor := Save_Cursor;  // Always mouse restore to normal
  end;
end;  // btnGetDomainIDClick

{******************************************************************************
  btnSetDomainIPClick
  Uses all of the information gathered to do a final form submit.  This is a
  two step process because 1and1 will only allow the IP to be set if you have
  first navigated to the page during that session.  You cannot just submit the
  data that page requires.  I assume that's to block just this sort of tool.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.btnSetDomainIPClick(Sender: TObject);
var
  Save_Cursor: TCursor;
begin // btnSetDomainIPClick
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;    // Show the hourglass cursor while working
  try
    if (not SubmitForm(WebBrowser, 'https://admin.1and1.com/xml/config/DomainOverview;jsessionid=' + lSession + '?__frame=',
      '__lf=' + HTTPEncode('MCPrivacyFlow') + '&' + '__sendingdata=' + HTTPEncode('1') + '&' + '__currentindex%5BDomainOverview%5D=' + HTTPEncode('0') + '&' + '__SYNT%3Ad1e523d0%3AdomainFilter.Set=' + HTTPEncode('true') + '&' +
      '__SYNT%3Ad1e523d0%3AextendedDomainFilter.Set=' + HTTPEncode('true') + '&' + '__SYNT%3Ad1e523d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('extendedDomainFilter') + '&' +
      '__SYNT%3Ad1e523d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainFilter') + '&' + '__SYNT%3Ad1e629d0%3AdomainPager.ShowNext=' + HTTPEncode('true') + '&' +
      '__SYNT%3Ad1e629d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainPager') + '&' + '__SYNT%3Ad1e635d0%3AdomainPager.ShowLast=' + HTTPEncode('true') + '&' +
      '__SYNT%3Ad1e635d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainPager') + '&' + '__SYNT%3Ad1e652d0%3AdomainPager.Interval=' + HTTPEncode('5') + '&' +
      '__SYNT%3Ad1e652d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainPager') + '&' + '__SYNT%3Ad1e672d0%3AdomainPager.Interval=' + HTTPEncode('20') + '&' +
      '__SYNT%3Ad1e672d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainPager') + '&' + '__SYNT%3Ad1e682d0%3AdomainPager.Interval=' + HTTPEncode('50') + '&' +
      '__SYNT%3Ad1e682d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainPager') + '&' + 'foo=' + HTTPEncode('') + '&' +
      '__SYNT%3Ad1e1108d0%3A__pageflow=' + HTTPEncode('settings_wizard_flow') + '&' + '__SYNT%3Ad1e1117d0%3A__pageflow=' + HTTPEncode('MCFlow') + '&' +
      '__SYNT%3Ad1e1126d0%3A__pageflow=' + HTTPEncode('dns_wizard_flow') + '&' + '__SYNT%3Ad1e1136d0%3A__pageflow=' + HTTPEncode('subdomain_delete_flow') + '&' +
      '__SYNT%3Ad1e1154d0%3A__pageflow=' + HTTPEncode('settings_info_flow') + '&' + 'domainFilter.DomainnameSubstring=' + HTTPEncode('') + '&' +
      '__SYNT%3Ad1e1187d0%3AdomainFilter.Set=' + HTTPEncode('true') + '&' + '__SYNT%3Ad1e1187d0%3AextendedDomainFilter.Set=' + HTTPEncode('true') + '&' +
      '__SYNT%3Ad1e1187d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('extendedDomainFilter') + '&' +
      '__SYNT%3Ad1e1187d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainFilter') + '&' + 'domainFilter.DomainType=' + HTTPEncode('all') + '&' +
      'extendedDomainFilter.TargetType=' + HTTPEncode('all') + '&' + 'extendedDomainFilter.FrontpageStatus=' + HTTPEncode('all') + '&' + '__SYNT%3Ad1e1295d0%3AdomainFilter.Set=' + HTTPEncode('true') + '&' +
      '__SYNT%3Ad1e1295d0%3AextendedDomainFilter.Set=' + HTTPEncode('true') + '&' + '__SYNT%3Ad1e1295d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('extendedDomainFilter') + '&' +
      '__SYNT%3Ad1e1295d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainFilter') + '&' + '__SYNT%3Ad1e1395d0%3AselectDomain.Action=' + HTTPEncode('reset') + '&' +
      '__SYNT%3Ad1e1395d0%3AdomainOrder.OrderBy=' + HTTPEncode('domainname') + '&' + '__SYNT%3Ad1e1395d0%3AdomainOrder.OrderAscending=' + HTTPEncode('true') + '&' +
      '__SYNT%3Ad1e1395d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('selectDomain') + '&' + '__SYNT%3Ad1e1395d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainOrder') + '&' +
      '__SYNT%3Ad1e1502d0%3AselectDomain.Action=' + HTTPEncode('reset') + '&' + '__SYNT%3Ad1e1502d0%3AdomainOrder.OrderBy=' + HTTPEncode('domaintype') + '&' +
      '__SYNT%3Ad1e1502d0%3AdomainOrder.OrderAscending=' + HTTPEncode('false') + '&' + '__SYNT%3Ad1e1502d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('selectDomain') + '&' +
      '__SYNT%3Ad1e1502d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainOrder') + '&' + '__SYNT%3Ad1e1702d0%3AselectDomain.Action=' + HTTPEncode('reset') + '&' +
      '__SYNT%3Ad1e1702d0%3AdomainOrder.OrderBy=' + HTTPEncode('state') + '&' + '__SYNT%3Ad1e1702d0%3AdomainOrder.OrderAscending=' + HTTPEncode('false') + '&' +
      '__SYNT%3Ad1e1702d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('selectDomain') + '&' +
      '__SYNT%3Ad1e1702d0%3A__CMD%5BDomainOverview%5D%3ASELWRP=' + HTTPEncode('domainOrder') + '&' +
      'domainOverview.DomainIds=' + HTTPEncode(editDomainID.Text) + '&' + '__pageflow=' + HTTPEncode('dns_flow2')
        ))
    then ShowMessage('FAILED TO REACH THE SET IP PAGE');


    if (not SubmitForm(WebBrowser, 'https://admin.1and1.com/xml/config/DomainNGDnsUpdate;jsessionid=' + lSession + '?__frame=_top',
      '__lf=dns_flow2&__sendingdata=1&__currentindex%5BDomainNGDnsUpdate%5D=0&dnsUpdate.UseCname=0&dnsUpdate.Cname=&dnsUpdate.UseCompanyNameserver=1&' +
      'dnsUpdate.Nameserver0=&dnsUpdate.UseCompanySecondaryNameserver=0&dnsUpdate.Nameserver1=&dnsUpdate.Nameserver2=&dnsUpdate.Nameserver3=&dnsUpdate.SelectIP=2&'+
      HTTPEncode('dnsUpdate.IP0') + '=' + HTTPEncode(editIP0.Text) + '&' + HTTPEncode('dnsUpdate.IP1') + '=' + HTTPEncode(editIP1.Text) + '&' + HTTPEncode('dnsUpdate.IP2') + '=' + HTTPEncode(editIP2.Text) + '&' + HTTPEncode('dnsUpdate.IP3') + '=' + HTTPEncode(editIP3.Text) + '&' +
      HTTPEncode('dnsUpdate.UseCompanyMx') + '=' + HTTPEncode('1') + '&' + HTTPEncode('dnsUpdate.UseCompanyMx') + '=' + HTTPEncode('0') + '&' + HTTPEncode('dnsUpdate.Mx0') + '=' + HTTPEncode(editUserName.Text) + '&' + HTTPEncode('dnsUpdate.Mx0Prio') + '=' + HTTPEncode('10') + '&' +
      'dnsUpdate.Mx1=&dnsUpdate.Mx1Prio=&dnsUpdate.UseBackupMx=0&dnsUpdate.Mx2=&dnsUpdate.Mx2Prio=&dnsUpdate.Mx3=&dnsUpdate.Mx3Prio=&__SYNT%3Ad1e1879d0%3AdnsReset.Reset=true&' +
      '__SYNT%3Ad1e1879d0%3A__CMD%5BDomainNGDnsUpdate%5D%3ASELWRP=dnsReset&__SBMT%3Ad1e1895d0%3A.x=18&__SBMT%3Ad1e1895d0%3A.y=15'
    ))
    then ShowMessage('FAILED TO SET IP');

  finally
    Screen.Cursor := Save_Cursor;  // Always mouse restore to normal
  end;
end;  // btnSetDomainIPClick

{******************************************************************************
  btnDoItAllClick
  This is a straight forward routine that simply clicks the buttons in order.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.btnDoItAllClick(Sender: TObject);
begin // btnDoItAllClick
  btnGetExternalIP.Click;
  if (not URLMatchesIP(editUserName.Text, editIP.Text))
  then begin
    btnGetSessionID.Click;
    btnLogin.Click;
    if (editDomainID.Text = '')
    then btnGetDomainID.Click;
    btnSetDomainIP.Click;
    if (Sender <> NIL)
    then ShowMessage('Done! 1and1 will process this change shortly.');
  end
  else begin
    if (Sender <> NIL)
    then ShowMessage('Domain already matches IP address.  Nothing to do.');
  end;
end;  // btnDoItAllClick


{******************************************************************************
  editUserNameChange
  Clear the Domain ID if a different Domain is enterred.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.editUserNameChange(Sender: TObject);
begin // editUserNameChange
  editDomainID.Text := '';
end;  // editUserNameChange

{******************************************************************************
  WebBrowserBeforeNavigate2
  For kicks and giggles, lets log the information being set over.
 ******************************************************************************}
procedure Tfrm1and1DynDNS.WebBrowserBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var
  S: String;
begin // WebBrowserBeforeNavigate2
  if (not xboxShowNavigationData.checked)
  then exit;

  S := VariantToStr(PostData);
  if (S <>'')
  then begin
    memoHeaders.Text :=  'URL USED' + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + VariantToStr(URL) + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + 'TARGET FRAME NAME' + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + VariantToStr(TargetFrameName) + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + 'FLAGS' + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + VariantToStr(Flags) + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + 'HEADERS' + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + VariantToStr(Headers) + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + 'CANCEL' + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + VariantToStr(Cancel) + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + 'POST DATA' + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + #13#10 + S;
  end
  else begin
    memoHeaders.Text :=  'URL USED' + #13#10;
    memoHeaders.Text :=  memoHeaders.Text + VariantToStr(URL);
  end;

end;  // WebBrowserBeforeNavigate2

procedure Tfrm1and1DynDNS.FormActivate(Sender: TObject);
begin
  if (ParamCount = 3)
  then begin
    editUserName.Text := ParamStr(1);
    editPassword.Text := ParamStr(2);
    editDomainID.Text := ParamStr(3);
    btnDoItAllClick(NIL);
    Application.Terminate;
  end
  else begin
    if (ParamCount > 0)
    then raise Exception.Create('Syntax Error: TCCDomainUpdater DOMAIN PASSWORD DOMAINID');
  end;
end;

end.

